(provide "casino-mode")
(in-package "editor")
(export '(casino-mode
          casino-toggle-map
          casino-goto
          casino-list-jackpot
          *casino-mode-map*
          *casino-dir*
          *casino-normalize*
          *casino-display-above-jackpot*
          *casino-10c-linediff*
          *casino-100c-linediff*
          *casino-10c-jackpot-list*
          *casino-100c-jackpot-list*
          *casino-10c-regexp-keyword-list*
          *casino-100c-regexp-keyword-list*
          ))

(defvar *casino-mode-syntax-table* nil)
(unless *casino-mode-syntax-table*
  (setq *casino-mode-syntax-table* (make-syntax-table))
  (dotimes (x 127)
    (let ((c (code-char x)))
      (unless (alphanumericp c)
        (set-syntax-symbol *casino-mode-syntax-table* c)))))

(defvar *casino-mode-map* nil)
(unless *casino-mode-map*
  (setq *casino-mode-map* (make-sparse-keymap))
  (define-key *casino-mode-map* #\TAB 'casino-toggle-map)
  (define-key *casino-mode-map* #\C-a 'casino-list-jackpot)
  (define-key *casino-mode-map* #\M-g 'casino-goto)
  )

(defvar *casino-dir* (etc-path)
  "10C.txt, 100C.txt ̒u")

(defvar *casino-normalize* 0.5
  "WI̒Oɓ邽߂̕␳(Pʂ͕b)BĂ܂ꍇ0.5菬At͑傫ύXB")

(defvar *casino-coloring-300k* '(:color 7 4 :bold :underline)
  "30(ȏ)̕C")
(defvar *casino-coloring-30k* '(:color 7 10 :bold :underline)
  "3`6")
(defvar *casino-coloring-3k* '(:color 7 2 :bold :underline)
  "3000`6000(10C\̂)")

(defvar *casino-display-above-jackpot* 15
  "ꗗWvہAWI肱̍sɔԁB")

(defvar *casino-10c-linediff* 15)

(defvar *casino-100c-linediff* (+ 0 *casino-display-above-jackpot*))

;; ̎(LQ) ] WIɂ郉C I KvRC l
;; 1:3000, 2:6000, 3:30000, 4:60000, 5:300000
(defvar *casino-10c-jackpot-list*
  '(
    (1 -13 2 "3/5" "10")
    (1 -2 4 "4/5" "10or30")
    (1 33 4 "3/5" "10")
    (1 35 5 "4/5" "20")
    (1 83 4 "4/5" "30")
    (1 274 3 "3/5" "10")
    (1 365 5 "3/5" "30")
    (3 492 4 "2/5" "30" "n:2/5")
    (1 657 2 "4/5" "30")
    (1 689 5 "3/5" "30")
    (1 698 4 "3/5" "30")
    (3 714 5 "1/5" "10" "n:3/5")
    (1 845 5 "4/5" "30")
    (1 917 6 "3/5" "10")
    (1 959 6 "3/5" "10")
    (5 1062 3 "1/5" "90" "n:2/5, n:2/5")
    (5 2831 2 "1/5" "90")
    (5 4527 2 "1/5" "80" "n:2/5, n:2/5")
    (5 4749 2 "1/5" "90")
    ))

(defvar *casino-100c-jackpot-list*
  '((5 19 1 "1/5" "900")
    (5 58 1 "1/5" "700")
    (5 123 1 "1/5" "800")
    (5 363 2 "1/5" "700" "6")
    (5 495 3 "1/5" "900")
    (5 644 5 "1/5" "800")
    (5 698 3 "1/5" "700")
    (5 1023 2 "1/5" "800")
    (5 1062 3 "1/5" "90" "10CXbg")
    (5 1150 2 "1/5" "900")
    (5 1208 2 "1/5" "800")
    (5 1265 2 "1/5" "900")
    (5 1297 4 "1/5" "800")
    (5 1541 2 "1/5" "800")
    (5 1982 5 "1/5" "700")
    (5 2831 2 "1/5" "90" "10CXbg")
    (5 3000 4 "3/5" "700")
    ;; (5 3003 2 "1/5" "800")
    (5 3071 4 "1/5" "900")
    (5 3156 5 "1/5" "800" "33")
    (5 3230 3 "1/5" "700")
    (5 3262 4 "1/5" "800")
    (5 3652 4 "1/5" "800")
    (5 3698 2 "1/5" "700")
    (5 3710 3 "1/5" "900")
    (5 3918 3 "2/5" "900")
    (5 4308 3 "1/5" "700")
    (5 4527 2 "1/5" "90" "10CXbg")
    (5 4570 2 "1/5" "700")
    (5 4749 2 "1/5" "90" "10CXbg")
    (5 4977 5 "1/5" "900")
    ))

(defvar *casino-10c-regexp-keyword-list*
  (compile-regexp-keyword-list
   `(
     ;; 10c-77777 30
     ("\\<\\(77777\\)[765432]\\{10\\}\\>" nil ,*casino-coloring-300k* nil 1 1)
     ("\\<[765432]\\{5\\}\\(77777\\)[765432]\\{5\\}\\>" nil ,*casino-coloring-300k* nil 1 1)
     ("\\<[765432]\\{10\\}\\(77777\\)\\>" nil ,*casino-coloring-300k* nil 1 1)
     ;; 10c-55555 3
     ("\\<\\(55555\\)[765432]\\{10\\}\\>" nil ,*casino-coloring-30k* nil 1 1)
     ("\\<[765432]\\{5\\}\\(55555\\)[765432]\\{5\\}\\>" nil ,*casino-coloring-30k* nil 1 1)
     ("\\<[765432]\\{10\\}\\(55555\\)\\>" nil ,*casino-coloring-30k* nil 1 1)
     ;; 10c-44444 6
     ("\\<\\(44444\\)[765432]\\{10\\}\\>" nil ,*casino-coloring-3k* nil 1 1)
     ("\\<[765432]\\{5\\}\\(44444\\)[765432]\\{5\\}\\>" nil ,*casino-coloring-3k* nil 1 1)
     ("\\<[765432]\\{10\\}\\(44444\\)\\>" nil ,*casino-coloring-3k* nil 1 1)
     ;; 10c-33333 3
     ("\\<\\(33333\\)[765432]\\{10\\}\\>" nil ,*casino-coloring-3k* nil 1 1)
     ("\\<[765432]\\{5\\}\\(33333\\)[765432]\\{5\\}\\>" nil ,*casino-coloring-3k* nil 1 1)
     ("\\<[765432]\\{10\\}\\(33333\\)\\>" nil ,*casino-coloring-3k* nil 1 1)
     ;; 10c-7777 3
     ("\\<\\(7777\\)[765432]\\{11\\}\\>" nil ,*casino-coloring-30k* nil 1 1)
     ("\\<[765432]\\{1\\}\\(7777\\)[765432]\\{10\\}\\>" nil ,*casino-coloring-30k* nil 1 1)
     ("\\<[765432]\\{5\\}\\(7777\\)[765432]\\{6\\}\\>" nil ,*casino-coloring-30k* nil 1 1)
     ("\\<[765432]\\{6\\}\\(7777\\)[765432]\\{5\\}\\>" nil ,*casino-coloring-30k* nil 1 1)
     ("\\<[765432]\\{10\\}\\(7777\\)[765432]\\{1\\}\\>" nil ,*casino-coloring-30k* nil 1 1)
     ("\\<[765432]\\{11\\}\\(7777\\)\\>" nil ,*casino-coloring-30k* nil 1 1)
     ;; 10c-6666 6
     ("\\<\\(6666\\)[765432]\\{11\\}\\>" nil ,*casino-coloring-3k* nil 1 1)
     ("\\<[765432]\\{1\\}\\(6666\\)[765432]\\{10\\}\\>" nil ,*casino-coloring-3k* nil 1 1)
     ("\\<[765432]\\{5\\}\\(6666\\)[765432]\\{6\\}\\>" nil ,*casino-coloring-3k* nil 1 1)
     ("\\<[765432]\\{6\\}\\(6666\\)[765432]\\{5\\}\\>" nil ,*casino-coloring-3k* nil 1 1)
     ("\\<[765432]\\{10\\}\\(6666\\)[765432]\\{1\\}\\>" nil ,*casino-coloring-3k* nil 1 1)
     ("\\<[765432]\\{11\\}\\(6666\\)\\>" nil ,*casino-coloring-3k* nil 1 1)
     ;; 10c-5555 3
     ("\\<\\(5555\\)[765432]\\{11\\}\\>" nil ,*casino-coloring-3k* nil 1 1)
     ("\\<[765432]\\{1\\}\\(5555\\)[765432]\\{10\\}\\>" nil ,*casino-coloring-3k* nil 1 1)
     ("\\<[765432]\\{5\\}\\(5555\\)[765432]\\{6\\}\\>" nil ,*casino-coloring-3k* nil 1 1)
     ("\\<[765432]\\{6\\}\\(5555\\)[765432]\\{5\\}\\>" nil ,*casino-coloring-3k* nil 1 1)
     ("\\<[765432]\\{10\\}\\(5555\\)[765432]\\{1\\}\\>" nil ,*casino-coloring-3k* nil 1 1)
     ("\\<[765432]\\{11\\}\\(5555\\)\\>" nil ,*casino-coloring-3k* nil 1 1)
     ;; 10c-777 3
     ("\\<\\(777\\)[765432]\\{12\\}\\>" nil ,*casino-coloring-3k* nil 1 1)
     ("\\<[765432]\\{1\\}\\(777\\)[765432]\\{11\\}\\>" nil ,*casino-coloring-3k* nil 1 1)
     ("\\<[765432]\\{2\\}\\(777\\)[765432]\\{10\\}\\>" nil ,*casino-coloring-3k* nil 1 1)
     ("\\<[765432]\\{5\\}\\(777\\)[765432]\\{7\\}\\>" nil ,*casino-coloring-3k* nil 1 1)
     ("\\<[765432]\\{6\\}\\(777\\)[765432]\\{6\\}\\>" nil ,*casino-coloring-3k* nil 1 1)
     ("\\<[765432]\\{7\\}\\(777\\)[765432]\\{5\\}\\>" nil ,*casino-coloring-3k* nil 1 1)
     ("\\<[765432]\\{10\\}\\(777\\)[765432]\\{2\\}\\>" nil ,*casino-coloring-3k* nil 1 1)
     ("\\<[765432]\\{11\\}\\(777\\)[765432]\\{1\\}\\>" nil ,*casino-coloring-3k* nil 1 1)
     ("\\<[765432]\\{12\\}\\(777\\)\\>" nil ,*casino-coloring-3k* nil 1 1)
     ;; ҂
     ("\\> \\( ?+\\*-?[0-9]+\\)" t (:color 8 6) nil 1 1)
     )))

(defvar *casino-100c-regexp-keyword-list*
  (compile-regexp-keyword-list
   `(
     ;; 100c-77777 300
     ("\\<\\(77777\\)[765432]\\{10\\}\\>" nil ,*casino-coloring-300k* nil 1 1)
     ("\\<[765432]\\{5\\}\\(77777\\)[765432]\\{5\\}\\>" nil ,*casino-coloring-300k* nil 1 1)
     ("\\<[765432]\\{10\\}\\(77777\\)\\>" nil ,*casino-coloring-300k* nil 1 1)
     ;; 100c-55555 30
     ("\\<\\(55555\\)[765432]\\{10\\}\\>" nil ,*casino-coloring-300k* nil 1 1)
     ("\\<[765432]\\{5\\}\\(55555\\)[765432]\\{5\\}\\>" nil ,*casino-coloring-300k* nil 1 1)
     ("\\<[765432]\\{10\\}\\(55555\\)\\>" nil ,*casino-coloring-300k* nil 1 1)
     ;; 100c-44444 6
     ("\\<\\(44444\\)[765432]\\{10\\}\\>" nil ,*casino-coloring-30k* nil 1 1)
     ("\\<[765432]\\{5\\}\\(44444\\)[765432]\\{5\\}\\>" nil ,*casino-coloring-30k* nil 1 1)
     ("\\<[765432]\\{10\\}\\(44444\\)\\>" nil ,*casino-coloring-30k* nil 1 1)
     ;; 100c-33333 3
     ("\\<\\(33333\\)[765432]\\{10\\}\\>" nil ,*casino-coloring-30k* nil 1 1)
     ("\\<[765432]\\{5\\}\\(33333\\)[765432]\\{5\\}\\>" nil ,*casino-coloring-30k* nil 1 1)
     ("\\<[765432]\\{10\\}\\(33333\\)\\>" nil ,*casino-coloring-30k* nil 1 1)
     ;; 100c-7777 30
     ("\\<\\(7777\\)[765432]\\{11\\}\\>" nil ,*casino-coloring-300k* nil 1 1)
     ("\\<[765432]\\{1\\}\\(7777\\)[765432]\\{10\\}\\>" nil ,*casino-coloring-300k* nil 1 1)
     ("\\<[765432]\\{5\\}\\(7777\\)[765432]\\{6\\}\\>" nil ,*casino-coloring-300k* nil 1 1)
     ("\\<[765432]\\{6\\}\\(7777\\)[765432]\\{5\\}\\>" nil ,*casino-coloring-300k* nil 1 1)
     ("\\<[765432]\\{10\\}\\(7777\\)[765432]\\{1\\}\\>" nil ,*casino-coloring-300k* nil 1 1)
     ("\\<[765432]\\{11\\}\\(7777\\)\\>" nil ,*casino-coloring-300k* nil 1 1)
     ;; 100c-6666 6
     ("\\<\\(6666\\)[765432]\\{11\\}\\>" nil ,*casino-coloring-30k* nil 1 1)
     ("\\<[765432]\\{1\\}\\(6666\\)[765432]\\{10\\}\\>" nil ,*casino-coloring-30k* nil 1 1)
     ("\\<[765432]\\{5\\}\\(6666\\)[765432]\\{6\\}\\>" nil ,*casino-coloring-30k* nil 1 1)
     ("\\<[765432]\\{6\\}\\(6666\\)[765432]\\{5\\}\\>" nil ,*casino-coloring-30k* nil 1 1)
     ("\\<[765432]\\{10\\}\\(6666\\)[765432]\\{1\\}\\>" nil ,*casino-coloring-30k* nil 1 1)
     ("\\<[765432]\\{11\\}\\(6666\\)\\>" nil ,*casino-coloring-30k* nil 1 1)
     ;; 100c-5555 3
     ("\\<\\(5555\\)[765432]\\{11\\}\\>" nil ,*casino-coloring-30k* nil 1 1)
     ("\\<[765432]\\{1\\}\\(5555\\)[765432]\\{10\\}\\>" nil ,*casino-coloring-30k* nil 1 1)
     ("\\<[765432]\\{5\\}\\(5555\\)[765432]\\{6\\}\\>" nil ,*casino-coloring-30k* nil 1 1)
     ("\\<[765432]\\{6\\}\\(5555\\)[765432]\\{5\\}\\>" nil ,*casino-coloring-30k* nil 1 1)
     ("\\<[765432]\\{10\\}\\(5555\\)[765432]\\{1\\}\\>" nil ,*casino-coloring-30k* nil 1 1)
     ("\\<[765432]\\{11\\}\\(5555\\)\\>" nil ,*casino-coloring-30k* nil 1 1)
     ;; 100c-777 3
     ("\\<\\(777\\)[765432]\\{12\\}\\>" nil ,*casino-coloring-30k* nil 1 1)
     ("\\<[765432]\\{1\\}\\(777\\)[765432]\\{11\\}\\>" nil ,*casino-coloring-30k* nil 1 1)
     ("\\<[765432]\\{2\\}\\(777\\)[765432]\\{10\\}\\>" nil ,*casino-coloring-30k* nil 1 1)
     ("\\<[765432]\\{5\\}\\(777\\)[765432]\\{7\\}\\>" nil ,*casino-coloring-30k* nil 1 1)
     ("\\<[765432]\\{6\\}\\(777\\)[765432]\\{6\\}\\>" nil ,*casino-coloring-30k* nil 1 1)
     ("\\<[765432]\\{7\\}\\(777\\)[765432]\\{5\\}\\>" nil ,*casino-coloring-30k* nil 1 1)
     ("\\<[765432]\\{10\\}\\(777\\)[765432]\\{2\\}\\>" nil ,*casino-coloring-30k* nil 1 1)
     ("\\<[765432]\\{11\\}\\(777\\)[765432]\\{1\\}\\>" nil ,*casino-coloring-30k* nil 1 1)
     ("\\<[765432]\\{12\\}\\(777\\)\\>" nil ,*casino-coloring-30k* nil 1 1)
     ;; ҂
     ("^ *\\*-?[0-9]+" t (:color 8 6))
     )))

(defun casino-100cp ()
  (string-matchp "100C\\.txt$" (get-buffer-file-name)))

(defun casino-get-x (&optional point)
  (save-excursion
    (let ((p (or point (point))))
      (goto-bol)
      (or (looking-at ".*?\\([^ ]\\{15\\}\\) +\\([^ ]\\{15\\}\\) +\\([^ ]\\{15\\}\\) +\\([^ ]\\{15\\}\\) +\\([^ ]\\{15\\}\\)")
          (error "oڂ̍sł͂܂"))
      (cond ((< p (match-beginning 2))
             1)
            ((< p (match-beginning 3))
             2)
            ((< p (match-beginning 4))
             3)
            ((< p (match-beginning 5))
             4)
            (t
             5)))))

(defun casino-set-x (x)
  (or (<= 1 x 5)
      (error "C͈̔͂𒴂Ă܂: ~d" x))
  (goto-bol)
  (or (looking-at ".*?\\([^ ]\\{15\\}\\) +\\([^ ]\\{15\\}\\) +\\([^ ]\\{15\\}\\) +\\([^ ]\\{15\\}\\) +\\([^ ]\\{15\\}\\)")
      (error "oڂ̍sł͂܂"))
  (goto-char (match-beginning x)))

(defun casino-get-y (&optional point)
  (save-excursion
    (when point
      (goto-char point))
    (- (current-line-number)
       (if (casino-100cp)
           *casino-100c-linediff*
         *casino-10c-linediff*))))

(defun casino-set-y (y)
  (goto-line (+ y
                (if (casino-100cp)
                    *casino-100c-linediff*
                  *casino-10c-linediff*))))

(defun casino-toggle-map ()
  "݈ʒuۑA100C\10C\؂ւ"
  (interactive)
  (let ((y (casino-get-y))
        (x (casino-get-x))
        (target (merge-pathnames (if (casino-100cp)
                                     "10C.txt"
                                   "100C.txt")
                                 *casino-dir*)))
    (find-file target)
    (casino-set-y y)
    (casino-set-x x)
    (recenter 0)))

(defun casino-goto (y-x)
  "][-C]̌`Ŏw肵Ĉړ"
  (interactive "sRoll[-Line] to goto: ")
  (if (string-match "\\(-?[0-9]+\\)\\(?:-\\([0-9]+\\)\\)?" y-x)
      (let ((y (match-string 1))
            (x (match-string 2)))
        (casino-set-y (parse-integer y))
        (when x
          (casino-set-x (parse-integer x))))
    nil))

(defun casino-wait-to-str (wait)
  (let ((f (/ (fround wait
                      0.01)
              100)))
    (multiple-value-bind (m s)
        (truncate f 60)
      (format nil "~2,'0dF~5,2,,,'0f" m s))))

(defun casino-calc-wait (from to)
  (+ (/ (- (car to) (car from)) 6)
     (* (- (cdr to) (cdr from)) 1/30)))

(defun casino-build-summary-of-jackpots ()
  "݈ʒuȍ~̓ڂƂ̑҂Ԃ̈ꗗ\z"
  (let* ((result nil)
         (y (casino-get-y))
         (x (casino-get-x))
         (jl (if (casino-100cp)
                 *casino-100c-jackpot-list*
               *casino-10c-jackpot-list*)))
    (push (list "]" ;; 10Cłu]vgĂ
                "҂ԁ@@@@I@KvC@l") result)
    (dolist (i jl (nreverse result))
      (multiple-value-bind (type yy xx prob coin note)
          (values-list i)
        (when (< (+ y 12) yy)
          (let ((line (+ yy
                         (if (casino-100cp)
                             *casino-100c-linediff*
                           *casino-10c-linediff*)
                         (- *casino-display-above-jackpot*)))
                (index (format nil "~a	~a	~a	~a	~a"
                               (casino-wait-to-str (+ (casino-calc-wait (cons y x) (cons yy xx))
                                                      *casino-normalize*))
                               (cdr (assoc type
                                           '((0 . "-")
                                             (1 . "n")
                                             (2 . "2n")
                                             (3 . "n")
                                             (4 . "2n")
                                             (5 . "30"))))
                               prob
                               (or coin "	")
                               (if note (concat "" note) "")
                               )))
            (push (list line index) result)))))
    ))

(defun casino-list-jackpot ()
  "list-function̑"
  (interactive)
  (setq *list-function-buffer* nil) ;; KXgč\z
  (when (list-function)
    (recenter 0)))

(defun casino-mode ()
  (interactive)
  (kill-all-local-variables)
  (setq mode-name
        (if (casino-100cp) "100C" "10C"))
  (setq buffer-mode 'casino-mode)
  (use-syntax-table *casino-mode-syntax-table*)
  (use-keymap *casino-mode-map*)
  (make-local-variable 'paragraph-start)
  (setq paragraph-start "^$\\|\f")
  (make-local-variable 'paragraph-separate)
  (setq paragraph-separate paragraph-start)
  (make-local-variable 'build-summary-function)
  (setq build-summary-function 'casino-build-summary-of-jackpots)
  (make-local-variable 'regexp-keyword-list)
  (setq regexp-keyword-list
        (if (casino-100cp)
            *casino-100c-regexp-keyword-list*
          *casino-10c-regexp-keyword-list*)))
